pub fn pack_u16(value:u16) -> Vec<u8>
{
    vec![(value >> 8) as u8, (value & 0xFF) as u8]
}

pub fn unpack_u16(data:&Vec<u8>, index:&mut usize) -> u16
{
    let mut result :u16 = 0;
    if *index < data.len() {
        result = (data[*index] as u16) << 8;
        *index += 1;
    }
    if *index < data.len() {
        result |= data[*index] as u16;
        *index += 1;
    }
    result
}

pub fn pack_u32(value:u32) -> Vec<u8>
{
    vec![
        (value >> 24) as u8,
        (value >> 16) as u8,
        (value >> 8) as u8,
        (value & 0xFF) as u8,
    ]
}

pub fn unpack_u32(data:&Vec<u8>, index:&mut usize) -> u32
{
    let mut result :u32 = 0;
    if *index < data.len() {
        result = (data[*index] as u32) << 24;
        *index += 1;
    }
    if *index < data.len() {
        result = (data[*index] as u32) << 16;
        *index += 1;
    }
    if *index < data.len() {
        result = (data[*index] as u32) << 8;
        *index += 1;
    }
    if *index < data.len() {
        result |= data[*index] as u32;
        *index += 1;
    }
    result
}
